#!/usr/bin/env python
# -*- coding: utf-8 -*-
# checkLdap.py - main daemon module
#
# Copyright (C) 2014 Gobierno de Extremadura.
#
# Mainteinner: Rafael Jesús García Perdigón <rafael.garciap@gobex.es>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301 USA

from daemon import runner# Es de terceras partes, por lo que hay que instalarlo.
import os
from time import sleep

PIDFILE = "/var/run/checkLdap/checkLdap.pid"


class Checkdaemon():
	
	def __init__(self):
		self.stdin_path = '/dev/null'
	        self.stdout_path = '/dev/null'
        	self.stderr_path = '/dev/null'
	        self.pidfile_path =  PIDFILE
        	self.pidfile_timeout = 5
	
	def run(self):

		while True:
			ping = os.system('/bin/ping -c 1 ldap')
			nslcd = os.system('/usr/sbin/nslcd --check')
			
			if ping != 0: 
				if nslcd == 0:
					service = os.system('service nslcd stop')
					service = os.system ('logger -i -t "checkLdapDaemon" "Service nslcd stopped"')
			else: 
				if nslcd != 0:
					service = os.system('service nslcd start')
					service = os.system ('logger -i -t "checkLdapDaemon" "Service nslcd started"')

			sleep(5)
			
			


if __name__ == '__main__':
 
 #Creamos el objeto demonio y lo inicializamos.
 checkdaemon = Checkdaemon()
 
 #Arrancamos el demonio.
 daemon_runner = runner.DaemonRunner(checkdaemon)
 daemon_runner.do_action()

